//
//			() 2004, ..,    18781.
//
//		     *.sav     ,    COMi:.
//	  :
//
//			ve1write .sav [_] [/c:_] [/f] [/r]
//
//				.sav -    .   !
//				_ - ,     (  com1:),    .
//				/c: -        (  - 0x01C0)
//				/f  -   1024    (     16 )
//				/r  -     .
//
//		  1.00  11.04.2004
//
//


#include <stdio.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <windows.h>


HANDLE		forComm = NULL;				//      COM-.
char		chars[] = {'|', '/', '-', '\\'};
long		masks[] = {0x8000, 0x4000, 0x2000, 0x1000, 0x0800, 0x0400, 0x0200, 0x0100, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};


void message()
	//      .
{	printf("*** Error : illegal number of parameters or incorrect parameter\n");
	printf(" Use ve1write ProgramFile ComPort [/keys]\n");
	printf("	/c:0xNNNN - content of configuration register (default is 0x01C0)\n");
	printf("	/f - full check of writed program (default is only first 16 bytes)\n");
	printf("	/r - russian messages\n");
	exit(1);
}


bool WaitSignal(bool ON,int delay,int sleep,char *msg)
	//     .
{DWORD		forModemStatus;

	if (msg != NULL) printf("%s            \r",msg);
	
	for (int iPoz = 0; iPoz < delay; iPoz++)			//   (PB1=0)
		{WaitCommEvent(forComm,&forModemStatus,NULL);
		 GetCommModemStatus(forComm,&forModemStatus);
		 if (ON)	//   .
			{if ((forModemStatus & MS_CTS_ON) != 0) return true;}
		 else		//   
			{if ((forModemStatus & MS_CTS_ON) == 0) return true;}
		 if (msg != NULL)		//      .
			printf("%s  %c          \r",msg,chars[iPoz % 4]);
		 Sleep(sleep);
		}

	return	false;
}


int main(int argc, char* argv[])
{DWORD		forModemStatus, conf1;		int		iPoz, iCurs, iNum, FileId;
 WORD		conf = 0x01C0, test = 16;	WORD	info[1024];
 char		ProgramFile[MAX_PATH], ComPort[MAX_PATH] = "com1:", forMsg[20];
 bool		russian = false;


	if (argc > 1) strcpy(ProgramFile,argv[1]); else message();		//   .
	if (argc > 2 && *argv[2] != '/') {strcpy(ComPort,argv[2]);	iNum = 3;} else iNum = 2;
	for (iPoz = iNum; iPoz < argc; iPoz++)
		if (!strncmp(argv[iPoz],"/c:",3) || !strncmp(argv[iPoz],"/C:",3))
			sscanf(argv[iPoz] + 3,"%hx",&conf);
		else if (!strncmp(argv[iPoz],"/f",2) || !strncmp(argv[iPoz],"/F",2))
			test = 1024;
		else if (!strncmp(argv[iPoz],"/r",2) || !strncmp(argv[iPoz],"/R",2))
			russian = true;
		else message();


	if ((forComm = CreateFile(ComPort,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)) == NULL)
		{if (!russian) printf("*** %s not opened...\n",ComPort);
		 else printf("***      %s...\n",ComPort);
		 exit(2);
		}
	else	//    -  .
		{if ((FileId = _open(ProgramFile,_O_RDONLY)) == -1)	//    
			{if (!russian) printf("*** Can\'t open %s...",ProgramFile);
			 else printf("***     %s...",ProgramFile);
			 exit(2);
			}
		 
		 _lseek(FileId,512,SEEK_SET);				//      *.sav,
		 memset(info,0,sizeof(info));				//  512      .
		 _read(FileId,info,sizeof(info));			_close(FileId);

	 
		 EscapeCommFunction(forComm,CLRBREAK);
		 EscapeCommFunction(forComm,CLRDTR);
		 EscapeCommFunction(forComm,CLRRTS);

		 if (!russian) printf("> Connect programmator and press Enter...");
		 else printf(">     Enter...");
		 getc(stdin);

		 EscapeCommFunction(forComm,SETBREAK);		//   -   .
		 EscapeCommFunction(forComm,SETDTR);
		 EscapeCommFunction(forComm,SETRTS);

		 Sleep(2000);								//     !

		 if (!WaitSignal(false,300,100,!russian ? "conn " : " "))
			{if (!russian) printf("*** Timeout while clearing...\n");
			 else printf("***     ...\n");
			 goto exit1;
			}

		 //    -   .
		 EscapeCommFunction(forComm,SETDTR);		//   ,    (PB0=1).
		 EscapeCommFunction(forComm,CLRBREAK);		//     (PB2=0).

		 if (!WaitSignal(true,100,100,!russian ? "cmd1+" : "1+"))
			{if (!russian) printf("*** Timeout at first part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //       .
		 EscapeCommFunction(forComm,SETBREAK);		//     (PB2=1).
		 EscapeCommFunction(forComm,SETDTR);		//  .
			 
		 if (!WaitSignal(false,100,100,!russian ? "cmd1-" : "1-"))
			{if (!russian) printf("*** Timeout at first part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //       .
		 EscapeCommFunction(forComm,SETDTR);		//  ,    (PB0=1).
		 EscapeCommFunction(forComm,CLRBREAK);		//     (PB2=0).

		 if (!WaitSignal(true,100,100,!russian ? "cmd2+" : "2+"))
			{if (!russian) printf("*** Timeout at second part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		//       .
		 EscapeCommFunction(forComm,SETBREAK);		//  .
		 EscapeCommFunction(forComm,SETDTR);		//     (PB2=1).
		 EscapeCommFunction(forComm,SETRTS);		//  .
			 
		 if (!WaitSignal(false,100,100,!russian ? "cmd2-" : "2-"))
			{if (!russian) printf("*** Timeout at second part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //  	   .
		 for (iCurs = 0; iCurs < 1024; iCurs++)
			{conf1 = info[iCurs];

			 EscapeCommFunction(forComm,SETDTR);		//  .
			 EscapeCommFunction(forComm,SETRTS);		//  .
			 EscapeCommFunction(forComm,CLRBREAK);		//  .

			 if (!WaitSignal(true,10,10,NULL))			//     .
				{if (!russian) printf("*** Timeout when strobed...\n");
				 else printf("***      ...");
				 goto exit1;
				}
		 
			 EscapeCommFunction(forComm,SETRTS);	//  .				 
				 
			 for (iPoz = 0; iPoz < 16; iPoz++)
				{EscapeCommFunction(forComm,CLRRTS);	//  .
			 	 if ((conf1 & 0x8000) != 0) EscapeCommFunction(forComm,SETDTR);
				 else EscapeCommFunction(forComm,CLRDTR);
				 EscapeCommFunction(forComm,SETRTS);	//  .				 
				 EscapeCommFunction(forComm,SETDTR);	//  .
				 conf1 <<= 1;
				}

			 EscapeCommFunction(forComm,SETRTS);		//  .
			 EscapeCommFunction(forComm,SETBREAK);		//  .
			 sprintf(forMsg,"%04x",iCurs);
					 
			 if (!WaitSignal(false,100,10,forMsg))		//      .
				{if (!russian) printf("*** Timeout when strobed off...\n");
				 else printf("***      ...");
				 goto exit1;
				}

			}

		 EscapeCommFunction(forComm,CLRBREAK);		//  .
//			 conf = 0x0000;
//			 conf = 0x0007;
//			 conf = 0x0038;	// 8 
//			 conf = 0x003F; // 8   
//			 conf = 0x01C0;	// .
//			 conf = 0x01C7;
//			 conf = 0x01F8;
//			 conf = 0x01FF;
		 for (iPoz = 0; iPoz < 16; iPoz++)
			{EscapeCommFunction(forComm,SETRTS);
			 if (conf & 0x8000) EscapeCommFunction(forComm,SETDTR);
			 else EscapeCommFunction(forComm,CLRDTR);
			 EscapeCommFunction(forComm,CLRRTS);	//  .
			 EscapeCommFunction(forComm,SETRTS);	//  .				 
			 EscapeCommFunction(forComm,SETDTR);	//  .
			 conf <<= 1;
			}
		 EscapeCommFunction(forComm,SETBREAK);		//  .

		 if (!WaitSignal(false,300,100,!russian ? "conf" : ""))		//      .
			{if (!russian) printf("*** Timeout when configured...\n");
			 else printf("***     ...");
			 goto exit1;
			}

		 EscapeCommFunction(forComm,CLRDTR);		//  .
		 EscapeCommFunction(forComm,SETRTS);		//  .
		 EscapeCommFunction(forComm,CLRBREAK);		//  .

		 if (!WaitSignal(false,300,100,!russian ? "conf" : ""))		//      .
			{if (!russian) printf("*** Timeout when configured...\n");
			 else printf("***     ...");
			 goto exit1;
			}

		 EscapeCommFunction(forComm,SETDTR);		//   ,    (PB0=1).
		 EscapeCommFunction(forComm,SETRTS);		//   ,    (PB0=1).
		 EscapeCommFunction(forComm,SETBREAK);		//   ,    (PB0=1).
		 if (!russian) printf("Program was writtten successfully...\n");
		 else printf("  ...\n");

// ------------------------------

		 EscapeCommFunction(forComm,SETDTR);		//   ,    (PB0=1).
		 EscapeCommFunction(forComm,CLRBREAK);		//     (PB2=0).

		 if (!WaitSignal(true,100,100,!russian ? "cmd1+" : "1+"))
			{if (!russian) printf("*** Timeout at first part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //       .
		 EscapeCommFunction(forComm,SETDTR);		//  .
		 EscapeCommFunction(forComm,SETBREAK);		//     (PB2=1).
			 
		 if (!WaitSignal(false,100,100,!russian ? "cmd1-" : "1-"))
			{if (!russian) printf("*** Timeout at first part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //       .
		 EscapeCommFunction(forComm,SETRTS);
		 EscapeCommFunction(forComm,CLRDTR);		//  ,    (PB0=0).
		 EscapeCommFunction(forComm,CLRBREAK);		//     (PB2=0).

		 if (!WaitSignal(true,100,100,!russian ? "cmd2+" : "2+"))
			{if (!russian) printf("*** Timeout at second part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //       .
		 EscapeCommFunction(forComm,SETBREAK);		//  .
		 EscapeCommFunction(forComm,SETDTR);		//     (PB2=1).
		 EscapeCommFunction(forComm,SETRTS);		//     (PB2=1).

		 if (!WaitSignal(false,100,100,!russian ? "cmd2+" : "2+"))
			{if (!russian) printf("*** Timeout at second part of command...\n");
			 else printf("***       ...");
			 goto exit1;
			}

		 //  	   .
		 for (iCurs = 0; iCurs < test; iCurs++)
			{conf1 = 0;		sprintf(forMsg,"%04x",iCurs);
			 for (iNum = (iCurs == 0 ? 2 : 0); iNum < 16; iNum++)
				{if (!WaitSignal(false,1000,10,forMsg))
					{if (!russian) printf("*** Timeout while reading...\n");
					 else printf("***    ...");
					 goto exit1;
					}

				 GetCommModemStatus(forComm,&forModemStatus);
				 conf1 = (conf1 >> 1 ) | ((forModemStatus & MS_DSR_ON) ? 0x80000000 : 0x00000000);

				 EscapeCommFunction(forComm,SETDTR);		//     (PB2=1).
				 EscapeCommFunction(forComm,CLRBREAK);		//  .

				 for (iPoz = 0; iPoz < 2000; iPoz++)		//   (PB1=0)
					{WaitCommEvent(forComm,&forModemStatus,NULL);	//   , ..    !
					 GetCommModemStatus(forComm,&forModemStatus);
					 if ((forModemStatus & MS_CTS_ON) != 0 && (forModemStatus & MS_DSR_ON) != 0) goto cont17;
					 Sleep(10);
					}
				 goto exit1;

cont17:			 EscapeCommFunction(forComm,SETBREAK);		//  .
				}

			 conf1 >>= 16;
			 if (conf1 != info[iCurs])
				{if (!russian) printf("*** Error %08x %04x!!!!\n",conf1,info[iCurs]);
				 else printf("***   %08x %04x!!!!\n",conf1,info[iCurs]);
				 goto exit1;
				}
			}

exit1:	 EscapeCommFunction(forComm,CLRBREAK);
		 EscapeCommFunction(forComm,CLRDTR);
		 EscapeCommFunction(forComm,CLRRTS);
			 
			 
		 if (!russian) printf("> Disconnect programmator and press Enter...");
		 else printf(">     Enter...");
		 getc(stdin);
			 
		 CloseHandle(forComm);		
		}

	return 0;
}

